local mPhotonView, mJavaBridge = ...

local mRecyclerView = nil
local mActivityContext = nil
local mUpdateTextView = nil
local mBottomLayout = nil
local mRealListData = nil
local mStateList = nil
local mAppCount = 0
local mUpdateAppCount = 0
local mButtonState = 0
local mContextData = nil
local mDisplayBtn = "0"
local isDev = false

local mDefaultShowNum = 0
local mRecommendUpdateAppOriginSize = 0 --原始推荐更新的APP个数
local mRecommendUpdateSizeTitle = 0 --标题展示的个数
local mNormalUpdateAppOriginSize = 0 --原始待更新的APP个数
local mNormalUpdateSizeTitle = 0 --标题展示的个数
local mRecommendUpdateAppSize = 0 --实际展示推荐更新的APP个数
local mNormalUpdateAppSize = 0 --实际展示待更新的APP个数
local mAllViewList --原始viewlist
local mAllDataList --原始datalist
local mRealShowViewList --实际展示viewlist
local mRealShowDataList --实际展示datalist

local mNormalCardTypeRecommend = "recommend_update_local_card_"
local mNormalCardTypeNormal = "normal_update_local_card_"

local systemTime = 0
local lastClickTime = 0
local uni_related_appid = ''

local mIgnoreListData = nil
local tempIgnoreListData = nil

local ContinueDownDialogListener = {}
local mContinueDownDialogListener = luajava.createProxy('com.tencent.rapidview.utils.DownloadUtils$ContinueDownDialogListener', ContinueDownDialogListener)

local RefreshUpdateStateListener = {}
local mRefreshUpdateStateListener = luajava.createProxy('com.tencent.assistant.module.update.UpdatePhotonListManager$RefreshUpdateStateListener', RefreshUpdateStateListener)

PhotonActionListener = {}
function PhotonActionListener.notify(key, value)
	mJavaBridge:Log("UpdateListLoader", "key:  " .. tostring(key) .. ", value: " .. value)
	if key == "changeState" then
		mJavaBridge:Log("UpdateListLoader", "准备获取状态" )
		local state = mJavaBridge:getAppState(mRealListData:get(value))
		mStateList:set(tonumber(value) , tostring(state))
		mJavaBridge:Log("UpdateAllBtn", "状态值:"..state)
		updateBtnState(false)
	elseif key == "showMore" then
		clickShowMore(value)
	elseif key == "ignoreUpdate" then
		local appid = splitString(value, ",")[1]
		local index = splitString(value, ",")[2]
		mJavaBridge:Log("UpdateListLoader", "appid:"..appid..", index:"..index)
		clickIgnoreUpdate(appid,index)
	elseif key == "showNewFeature" then
		updateShowAllNewFeatureState("true",value)
	elseif key == "hideNewFeature" then
		updateShowAllNewFeatureState("false",value)
	end
end

function updateShowAllNewFeatureState(state,index)
	mRecyclerView:getView():updateItemData(index,"isShowedNewFeatureAll",state)
end

function main()
	mActivityContext = mPhotonView:getView():getContext()
	mRecyclerView = mPhotonView:getParser():getChildView("main_recycler")
	mUpdateTextView = mPhotonView:getParser():getChildView("update_all_txt")
	mBottomLayout = mPhotonView:getParser():getChildView("bottom_layout")
	-- 全部更新状态
	mButtonState = 0
	mUpdateAppCount = 0
	systemTime = luajava.bindClass("java.lang.System")
	loadData()
end

function loadData()
	local params = {}

	params["GetAppUpdateRequest"] = getData("GetAppUpdateRequest")
	params["GetDownloadRelatedCardsRequest"] = getData("GetDownloadRelatedCardsRequest")
	params["contextSourceScene"] = getData("contextSourceScene")
	params["contextAppList"] = getData("contextAppList")

	mRealListData = luajava.newInstance("java.util.ArrayList")
	mStateList = luajava.newInstance("java.util.ArrayList")
	mIgnoreListData = luajava.newInstance("java.util.ArrayList")
	tempIgnoreListData = luajava.newInstance("java.util.ArrayList")

	requestStartReport()
	mJavaBridge:request(229, params, reqListener)
end

function reqListener(succ, serverListView, serverListData)
	if (succ == false or serverListView == nil or serverListData == nil) then
		mJavaBridge:Log("UpdateListLoader", "reqListener nil, return")
		onRequestFailed()
		return
	else 
		onRequestSucceed(serverListView, serverListData)
	end
end

function loadFinish()
    local errorContainer = mPhotonView:getParser():getChildView("error_container")
    local loadingContainer = mPhotonView:getParser():getChildView("loading_container")

    if (errorContainer ~= nil) then
        errorContainer:getParser():update("visibility", "gone")
    end

    if (loadingContainer ~= nil) then
        loadingContainer:getParser():update("visibility", "gone")
    end
end

function onRequestFailed()
    local errorContainer = mPhotonView:getParser():getChildView("error_container")
    local loadingContainer = mPhotonView:getParser():getChildView("loading_container")

    if (errorContainer ~= nil) then
        errorContainer:getParser():update("visibility", "visible")
    end

    if (loadingContainer ~= nil) then
        loadingContainer:getParser():update("visibility", "gone")
    end
end

function onRequestSucceed(serverListView, serverListData)	
	getContextData(serverListView, serverListData)

	mJavaBridge:Log("UpdateListLoader", "mDisplayBtn"..mDisplayBtn)

	mAllViewList = luajava.newInstance("java.util.ArrayList")
	mAllDataList = luajava.newInstance("java.util.ArrayList")

	local listIndex = 0
	local serverSubViewNum = serverListData:size() - 1
	-- 该部分数据，需从native透传
	local sourcescene = getData("sourcescene")
	local sourcesceneslotid = getData("sourcesceneslotid")
	local sourceModelType = getData("sourceModelType")
	local sourceSlotId = getData("sourceSlotId")
	for index = 0, serverSubViewNum do
		if (serverListView:get(index) == "update_page_bottom_recommend_card.xml") then
			local item_data_map = serverListData:get(index)
			putMapData(item_data_map, "type", "update_page_bottom_recommend_card")
			putMapData(item_data_map, "scene", mJavaBridge:create("var", 10110))
			putMapData(item_data_map, "sourcescene", mJavaBridge:create("var", sourcescene))
			putMapData(item_data_map, "sourcesceneslotid", mJavaBridge:create("var", sourcesceneslotid))
			local uni_update_app_num = 0
			if mAppCount ~= 0 then
				uni_update_app_num = 1
			end
			putMapData(item_data_map, "uni_update_app_num", uni_update_app_num)
			local iterators = item_data_map:keySet():iterator()			
            while (iterators:hasNext()) do
				local key = iterators:next()
				if key ~= nil and string.find(key,"item_data") == 1 then
					-- 增加底部「专属推荐数据」
					item_data_map:get(key):getObject():put("scene", mJavaBridge:create("var", 10110))
					item_data_map:get(key):getObject():put("sourceScene", mJavaBridge:create("var", sourcescene))
					item_data_map:get(key):getObject():put("sourceModelType", mJavaBridge:create("var", sourceModelType))
					item_data_map:get(key):getObject():put("sourceSlotId", mJavaBridge:create("var", sourcesceneslotid))
				end
			end
			mAllViewList:add(serverListView:get(index))
			mAllDataList:add(item_data_map)
		elseif (serverListView:get(index) == "update_list_normal_card.xml") then
			mAllViewList:add(serverListView:get(index))
			local item_data = serverListData:get(index):get("item_data_1"):getObject()
			local type = serverListData:get(index):get("type"):getString()
			local sourcescene = getData("sourcescene")
			local sourcesceneslotid = getData("sourcesceneslotid")
			local type = serverListData:get(index):get("type"):getString()
			item_data:put("sourcescene", mJavaBridge:create("var", sourcescene))
			item_data:put("sourcesceneslotid", mJavaBridge:create("var", sourcesceneslotid))
			item_data:put("scene", mJavaBridge:create("var", 10110))
			item_data:put("type", mJavaBridge:create("var",type))
			item_data:put("modeltype", serverListData:get(index):get("modeltype"))
			item_data:put("recommendid_card", serverListData:get(index):get("recommendid_card"))
			item_data:put("listener", mJavaBridge:create("var", PhotonActionListener))
			item_data:put("listindex", mJavaBridge:create("var", listIndex))
			item_data:put("isShowedNewFeatureAll", mJavaBridge:create("var", "false"))
			if type == "recommend" then
				item_data:put("uni_card_title", mJavaBridge:create("var", "recd_update"))
			elseif type == "normal" then
				item_data:put("uni_card_title", mJavaBridge:create("var", "common_update"))
			end
			mAllDataList:add(item_data)
			
			if (serverListData:get(index):containsKey("type")) then
				mStateList:add(mJavaBridge:getAppState(item_data:get("app_simple_detail")))
				mRealListData:add(item_data:get("app_simple_detail"))
				if uni_related_appid == '' then
					uni_related_appid = tostring(item_data:get("app_id")) 
				else
					uni_related_appid = uni_related_appid..","..tostring(item_data:get("app_id"))
				end
			end
			listIndex = listIndex + 1
			mUpdateAppCount = mUpdateAppCount + 1
		end
		mPhotonView:getParser():getBinder():update("uni_related_appid", uni_related_appid)
	end

	mJavaBridge:setUpdateList(mRealListData)

	updateData()
	reportUpdatePageLoadTime()

	loadFinish()

	if isDev == true then
		-- 开发环境
		mJavaBridge:Log("UpdateListLoader", "开发环境")
		mStateList = mStateList:subList(0,3)
		mRealListData = mRealListData:subList(0,3)
	end

	updateBtnState(false)

	pageExposure()
	allBtnReport("100")
end

function getContextData(serverListView, serverListData)
	local tempSubViewNum = serverListData:size() - 1
	local noContextData = true --没待更新的应用时不会下发上文卡
	for i = 0, tempSubViewNum do
		-- 提取上文卡信息并移除上文卡
		if (serverListView:get(i) == "update_list_context.xml") then
			noContextData = false
			mContextData = serverListData:get(i)
			if (mContextData:get("recommend_size") ~= nil and mContextData:get("recommend_size"):getString() ~= "") then
				mRecommendUpdateAppOriginSize = tonumber(mContextData:get("recommend_size"):getString())
			else
				mRecommendUpdateAppOriginSize = 0
			end
			if (mContextData:get("normal_size") ~= nil and mContextData:get("normal_size"):getString() ~= "") then
				mNormalUpdateAppOriginSize = tonumber(mContextData:get("normal_size"):getString())
			else
				mNormalUpdateAppOriginSize = 0
			end
			if (mContextData:get("default_show_num") ~= nil and mContextData:get("default_show_num"):getString() ~= "") then
				mDefaultShowNum = tonumber(mContextData:get("default_show_num"):getString())
			else
				mDefaultShowNum = 0
			end
			mRecommendUpdateSizeTitle = mRecommendUpdateAppOriginSize
			mNormalUpdateSizeTitle = mNormalUpdateAppOriginSize
			mRecommendUpdateAppSize = mDefaultShowNum
			mNormalUpdateAppSize = mDefaultShowNum
			
			if mContextData:containsKey("is_display_update_all") then
				mDisplayBtn = tostring(mContextData:get("is_display_update_all"))
			end 
			mJavaBridge:Log("UpdateListLoader", "mDisplayBtn:"..mDisplayBtn)
			serverListView:remove(i)
			serverListData:remove(i)
			break
		end
	end

	local noUpdateLayout = mPhotonView:getParser():getChildView("no_update_layout")
	if (noContextData) then
		if (noUpdateLayout ~= nil) then
			noUpdateLayout:getParser():update("visibility", "visible")
		end
	else
		if (noUpdateLayout ~= nil) then
			noUpdateLayout:getParser():update("visibility", "gone")
		end
	end

	mAppCount = tonumber(mDefaultShowNum + mDefaultShowNum + 1)
end

function updateData()
	mRealShowViewList = luajava.newInstance("java.util.ArrayList")
	mRealShowDataList = luajava.newInstance("java.util.ArrayList")
	local recommend_size = mRecommendUpdateAppOriginSize
	local normal_size = mNormalUpdateAppOriginSize
	local allDataListSize = mAllDataList:size() - 1

	-- 插入推荐更新标题卡
	if (recommend_size > 0) then
		insertTitleCard(mNormalCardTypeRecommend, mRealShowViewList, mRealShowDataList)
	end
	local no = 0

	for index = 0, allDataListSize do
		local isAdd = true

		if (index == mDefaultShowNum and recommend_size > mDefaultShowNum) then
			-- 如果存在推荐更新卡，在其底部插入查看更多卡
			insertShowMoreCard(mNormalCardTypeRecommend, mRealShowViewList, mRealShowDataList)
			isAdd = false
		end

		if (index >= mDefaultShowNum and index <= (recommend_size - 1)) then
			-- 推荐更新卡需要出现查看更多卡时，先不展示部分待更新应用
			isAdd = false
		end

		if (index == recommend_size and normal_size > 0) then
			-- 插入普通待更新标题卡
			insertTitleCard(mNormalCardTypeNormal, mRealShowViewList, mRealShowDataList)
		end

		if ((index >= (recommend_size + mDefaultShowNum)) and (index <= (recommend_size + normal_size - 1))) then
			-- 普通更新卡需要出现查看更多卡时，先不展示部分待更新应用
			isAdd = false
		end

		if (isAdd) then
			local item_data = mAllDataList:get(index)
			item_data:put("real_show_index", mJavaBridge:create("var", no))
		    item_data:put("slotId", mJavaBridge:create("var", "99_"..(no+1)))
			no = no + 1

		    mRealShowViewList:add(mAllViewList:get(index))
		    mRealShowDataList:add(item_data)
		end

		if (index == (recommend_size + normal_size - 1) and normal_size > mDefaultShowNum) then
			-- 如果存在待更新卡，在其底部插入查看更多卡
			insertShowMoreCard(mNormalCardTypeNormal, mRealShowViewList, mRealShowDataList)
		end
	end

	mRecyclerView:getView():updateData(mRealShowDataList, mRealShowViewList, false)
end

function clickShowMore(type)
	local tempDataList = luajava.newInstance("java.util.ArrayList")
	local tempViewList = luajava.newInstance("java.util.ArrayList")
	for i = 0, mRealShowDataList:size() - 1 do
		tempDataList:add(mRealShowDataList:get(i))
		tempViewList:add(mRealShowViewList:get(i))
	end
	mRealShowDataList:clear()
	mRealShowViewList:clear()
	local is_recommend_expand = false
	local is_normal_expand = false

	if (type == mNormalCardTypeRecommend .. "show_more") then
		local showMoreCardIndex = -1
		for index = 0, tempDataList:size() - 1 do
			local item_data = tempDataList:get(index)
			local cardType = item_data:get("type")
			if (cardType:getString() == (mNormalCardTypeRecommend .. "show_more")) then
				showMoreCardIndex = index
				break
			end
		end
		mJavaBridge:Log("UpdateListIndex", "clickShowMore showMoreCardIndex: " .. showMoreCardIndex)

		for index = 0, showMoreCardIndex -1 do
			mRealShowDataList:add(tempDataList:get(index))
			mRealShowViewList:add(tempViewList:get(index))
		end

		for index = mDefaultShowNum, mRecommendUpdateAppOriginSize - 1 do
			-- 插入之前未展示的推荐更新应用
			local item_data = mAllDataList:get(index)
			item_data:put("real_show_index", mJavaBridge:create("var", index))
		    item_data:put("slotId", mJavaBridge:create("var", "99_"..(index+1)))
			mJavaBridge:Log("UpdateListIndex", "clickShowMore 1 real_show_index:"..index)

			mRealShowDataList:add(item_data)
			mRealShowViewList:add(mAllViewList:get(index))
		end

		local count = 0
		for index = showMoreCardIndex + 1, tempDataList:size() -1 do
			local item_data = tempDataList:get(index)
			local real_show_index = mRecommendUpdateAppOriginSize + count
			local cardType = item_data:get("type")
			if cardType:getString() == "normal" then
				item_data:put("real_show_index", mJavaBridge:create("var", real_show_index))
				item_data:put("slotId", mJavaBridge:create("var", "99_"..real_show_index + 1))
				mJavaBridge:Log("UpdateListIndex", "clickShowMore 2 real_show_index:"..real_show_index)
				count = count + 1
			end

			mRealShowDataList:add(item_data)
			mRealShowViewList:add(tempViewList:get(index))
		end

		mRecommendUpdateAppSize = mRecommendUpdateAppOriginSize		
		is_recommend_expand = true
	elseif (type == mNormalCardTypeNormal .. "show_more") then
		local showMoreCardIndex = -1
		for index = 0, tempDataList:size() - 1 do
			local item_data = tempDataList:get(index)
			local cardType = item_data:get("type")
			if (cardType:getString() == (mNormalCardTypeNormal .. "show_more")) then
				showMoreCardIndex = index
				break
			end
		end
		mJavaBridge:Log("UpdateListIndex", "clickShowMore showMoreCardIndex: " .. showMoreCardIndex)

		for index = 0, showMoreCardIndex - 1 do
			mRealShowDataList:add(tempDataList:get(index))
			mRealShowViewList:add(tempViewList:get(index))
		end

		local count = 0
		for index = mRecommendUpdateAppOriginSize + mDefaultShowNum, mAllDataList:size() - 1 do
			-- 插入之前未展示的待更新应用
			local item_data = mAllDataList:get(index)
			local real_show_index = mRecommendUpdateAppSize + mDefaultShowNum + count
			count = count + 1
			item_data:put("real_show_index", mJavaBridge:create("var", real_show_index))
		    item_data:put("slotId", mJavaBridge:create("var", "99_"..(real_show_index+1)))
			mJavaBridge:Log("UpdateListIndex", "clickShowMore 3 real_show_index:"..real_show_index)

			mRealShowDataList:add(item_data)
			mRealShowViewList:add(mAllViewList:get(index))
		end
		is_normal_expand = true
	end

	if is_normal_expand == true and  is_recommend_expand == true then
		mAppCount = mNormalUpdateAppOriginSize + mRecommendUpdateAppSize + 1
	elseif is_normal_expand == true and  is_recommend_expand == false then
		mAppCount = mNormalUpdateAppOriginSize + mDefaultShowNum + 1
	elseif is_normal_expand == false and  is_recommend_expand == true then
		mAppCount = mRecommendUpdateAppSize + mDefaultShowNum + 1
	end
	mJavaBridge:Log("UpdateListLoader", "====mAppCount:"..mAppCount)

	mRecyclerView:getView():updateData(mRealShowDataList, mRealShowViewList, true)
end
  
function insertTitleCard(type, viewList, dataList)
	if (mContextData ~= nil) then
		local mapData = luajava.newInstance('java.util.HashMap')

		if (type == mNormalCardTypeRecommend) then

			local recommendSize = mRecommendUpdateAppOriginSize
			if (recommendSize > 0) then
				viewList:add("update_list_title_card.xml")
				putMapData(mapData, "title", mContextData:get("recommend_title"):getString() .. "（" .. mContextData:get("recommend_size"):getString() .. "）")
				putMapData(mapData, "size", mContextData:get("recommend_size"):getString())
				putMapData(mapData, "type", mNormalCardTypeRecommend .. "title")
				putMapData(mapData, "corner_type", "top_corner")

				local sourcescene = getData("sourcescene")
				local sourcesceneslotid = getData("sourcesceneslotid")
				putMapData(mapData, "sourcescene", mJavaBridge:create("var", sourcescene))
				putMapData(mapData, "sourcesceneslotid", mJavaBridge:create("var", sourcesceneslotid))
				putMapData(mapData, "scene", mJavaBridge:create("var", 10110))

				dataList:add(mapData)
			end

		elseif (type == mNormalCardTypeNormal) then

			local normal_size = mNormalUpdateAppOriginSize
			if (normal_size > 0) then
				viewList:add("update_list_title_card.xml")
				putMapData(mapData, "title", mContextData:get("nomal_title"):getString() .. "（" .. mContextData:get("normal_size"):getString() .. "）")
				putMapData(mapData, "size", mContextData:get("normal_size"):getString())
				putMapData(mapData, "type", mNormalCardTypeNormal .. "title")
				putMapData(mapData, "corner_type", "top_corner")

				local sourcescene = getData("sourcescene")
				local sourcesceneslotid = getData("sourcesceneslotid")
				putMapData(mapData, "sourcescene", mJavaBridge:create("var", sourcescene))
				putMapData(mapData, "sourcesceneslotid", mJavaBridge:create("var", sourcesceneslotid))
				putMapData(mapData, "scene", mJavaBridge:create("var", 10110))

				dataList:add(mapData)
			end
			
		end	
	end
end

function insertShowMoreCard(type, viewList, dataList)
	viewList:add("update_list_show_more_card.xml")
	local mapData = luajava.newInstance('java.util.HashMap')
	putMapData(mapData, "card_title", "查看更多")
	putMapData(mapData, "type", type .. "show_more")
	putMapData(mapData, "listener", PhotonActionListener)

	local sourcescene = getData("sourcescene")
	local sourcesceneslotid = getData("sourcesceneslotid")
	putMapData(mapData, "sourcescene", mJavaBridge:create("var", sourcescene))
	putMapData(mapData, "sourcesceneslotid", mJavaBridge:create("var", sourcesceneslotid))
	putMapData(mapData, "scene", mJavaBridge:create("var", 10110))

	dataList:add(mapData)
end

function getData(key)
	local data = mPhotonView:getParser():getBinder():get(key)
	if data == nil then
		data = ""
	end
	return data
end

function putMapData(map, key, value)
    if ((key ~= nil) and (value ~= nil)) then
        local var = mJavaBridge:create("var", value)
        map:put(key, var)
    end
end

function updateRecyclerviewBgColor()
	mRecyclerView:setBackgroundColor(Color:parseColor("#ffffff"))
end

function updateAll()
	mJavaBridge:Log("UpdateListLoader", "lastClickTime:"..lastClickTime)

	-- 设置点击间隔为1.5s
	if lastClickTime == 0 or systemTime:currentTimeMillis() - lastClickTime > 1500 then
	   lastClickTime = systemTime:currentTimeMillis()
	   mJavaBridge:Log("UpdateAllBtn", "updateBtnState, updateAll")
	   updateBtnState(true)
	end
end

function updateBtnState(isClick)
	if isClick == false then
		-- 非点击
		local all_count = 0
		local count = 0
		local downloading_count = 0
		local paused_count = 0

		if mStateList.size ~= 0 then
			local size = mStateList:size() -1
			for i=0,size do

				-- 排除忽略应用
				if tempIgnoreListData:contains(tonumber(i)) == false then
					mJavaBridge:Log("UpdateListLoader", "tempIgnoreListData包含数据"..i)

				if mStateList:get(i) == "UPDATE" 
				or mStateList:get(i) == "DOWNLOADING" 
				or mStateList:get(i) == "PAUSED" 
				or mStateList:get(i) == "QUEUING" then
					count = tonumber(count)  + 1
				end

				if mStateList:get(i) == "UPDATE" 
				or mStateList:get(i) == "DOWNLOADING" 
				or mStateList:get(i) == "PAUSED" 
				or mStateList:get(i) == "QUEUING" 
				or mStateList:get(i) == "DOWNLOADED" 
				or mStateList:get(i) == "DOWNLOAD" 
				or mStateList:get(i) == "FAIL" 
				or mStateList:get(i) == "MERGING" then
					all_count = tonumber(all_count)  + 1
				end
			
				if mStateList:get(i) == "DOWNLOADING" 
				or mStateList:get(i) == "QUEUING" then
					downloading_count = tonumber(downloading_count)  + 1
				end

				if mStateList:get(i) == "PAUSED" then
					paused_count = tonumber(paused_count)  + 1
				end
			    end
			end
		end

		mJavaBridge:Log("UpdateAllBtn", "mButtonState:"..mButtonState..", count:"..count..", all_count:"..all_count..", downloading_count:"..downloading_count..", paused_count:"..paused_count)

		if mButtonState == 0 then
			if all_count == 0 and tonumber(all_count) > 0 then
				mJavaBridge:Log("UpdateListLoader", "count == 0:")
				changeBtnVisible(0, -1, 8)
			elseif downloading_count == count and tonumber(count) > 0 then
				mJavaBridge:Log("UpdateList Loader", "downloading_count == count")
				changeBtnVisible(1, "全部暂停", 0)
			else
				mJavaBridge:Log("UpdateListLoader", "全部更新（共" .. count .. "个）")
				mJavaBridge:Log("UpdateAllBtn", "updateBtnState, 1")
				changeBtnVisible(0, "全部更新（共" .. all_count .. "个）", 0)
			end
		elseif mButtonState == 1 then
			if paused_count == count and tonumber(count) > 0 then
				mJavaBridge:Log("UpdateListLoader", "downloading_count == count")
				mJavaBridge:Log("UpdateAllBtn", "updateBtnState, 2")
				changeBtnVisible(2, "继续更新", 0)
			elseif downloading_count == 0 and paused_count == 0 then
				mJavaBridge:Log("UpdateListLoader", "全部更新（共" .. count .. "个）")
				mJavaBridge:Log("UpdateAllBtn", "updateBtnState, 3")
				changeBtnVisible(0, "全部更新（共" .. all_count .. "个）", 0)
			elseif downloading_count == 0 and paused_count > 0 then
				mJavaBridge:Log("UpdateAllBtn", "updateBtnState, 4")
				changeBtnVisible(2, "继续更新", 0)
			end
		elseif mButtonState == 2 then
			if downloading_count == count and tonumber(count) > 0 then
				mJavaBridge:Log("UpdateAllBtn", "downloading_count == count")
				changeBtnVisible(1, "全部暂停", 0)
			elseif downloading_count == 0 and paused_count == 0 then
				mJavaBridge:Log("UpdateAllBtn", "downloading_count == 0, 继续更新 -> 全部更新")
				changeBtnVisible(0, "全部更新（共" .. all_count .. "个）", 0)
			end
		end
	elseif isClick == true then
		-- 点击
		if mButtonState == 0 then
			-- 全部更新 -> 全部暂停
			allBtnReport("905")
			local realListData = mJavaBridge:getUpdateList()
			mJavaBridge:updateAppList(realListData, mIgnoreListData, false, true, mContinueDownDialogListener)

		elseif mButtonState == 1 then
			-- 全部暂停 —> 继续更新
			mJavaBridge:Log("UpdateAllBtn", "全部暂停 —> 继续更新")
			changeBtnVisible(2, "继续更新", 0)
			allBtnReport("224")
			local realListData = mJavaBridge:getUpdateList()
			mJavaBridge:pauseDownloadAllAPP(realListData, mIgnoreListData)

		elseif mButtonState == 2 then
			-- 继续更新 —> 全部暂停
			allBtnReport("225")
			local realListData = mJavaBridge:getUpdateList()
			mJavaBridge:updateAppList(realListData, mIgnoreListData, false, true, mContinueDownDialogListener)
		end
	end

end

function ContinueDownDialogListener.onDirectUpdateAndDialogNoShow()
	mJavaBridge:Log("UpdateAllBtn", "全部更新 -> 全部暂停")
	changeBtnVisible(1, "全部暂停", 0)
end

function ContinueDownDialogListener.onRightBtnClick()
	if (mButtonState == 0) then
		mJavaBridge:Log("UpdateAllBtn", "全部更新 -> 全部暂停")
		changeBtnVisible(1, "全部暂停", 0)
	elseif (mButtonState == 2) then
		mJavaBridge:Log("UpdateAllBtn", "继续更新 —> 全部暂停")
		changeBtnVisible(1, "全部暂停", 0)
	end
end

function RefreshUpdateStateListener.onRefreshUpdateStateFinish(stateList)
	mStateList = stateList
	if (mStateList == nil) then
		return
	end
	mJavaBridge:Log("UpdateAllBtn", "onRefreshUpdateStateFinish mStateList:"..tostring(mStateList:size()))
	updateBtnState(false)
end

function onResume()
	mJavaBridge:refreshUpdateAppStateList(mRealListData, mIgnoreListData, mRefreshUpdateStateListener)
end

function changeBtnVisible(state, textStr, visible)
	mJavaBridge:Log("UpdateListLoader", "mDisplayBtn===>"..mDisplayBtn)
	mJavaBridge:Log("UpdateListLoader", "state===>"..state)
	mJavaBridge:Log("UpdateListLoader", "textStr===>"..textStr)
	mJavaBridge:Log("UpdateListLoader", "visible===>"..visible)

	if (mPhotonView == nil) then
		return
	end

	if (mPhotonView:getParser() == nil) then
		return
	end

	if (mPhotonView:getParser():getChildView("main_recycler") == nil) then
		return
	end

	if mDisplayBtn == "0" then
		mBottomLayout:getView():setVisibility(8)
		mPhotonView:getParser():getChildView("main_recycler"):getParser():update("marginbottom", "0")
	elseif mDisplayBtn == "1" then
		if visible == 0 then
			mBottomLayout:getView():setVisibility(0)
			mButtonState = state
			mUpdateTextView:getView():setText(textStr)
			mJavaBridge:Log("UpdateListLoader", "设置margin")
			mPhotonView:getParser():getChildView("main_recycler"):getParser():update("marginbottom", 60)
		else
			mBottomLayout:getView():setVisibility(8)
			mPhotonView:getParser():getChildView("main_recycler"):getParser():update("marginbottom", "0")
		end
	end
end

function clickIgnoreUpdate(appId, stateIndex)
	if (mRealShowViewList ~= nil and mRealShowDataList ~= nil and mRecyclerView ~= nil) then	
		
		mJavaBridge:Log("ClickIgnoreUpdate", "appId:"..appId..", stateIndex:"..stateIndex)
		mAppCount = mAppCount - 1
		mIgnoreListData:add(tonumber(stateIndex))
		tempIgnoreListData:add(tonumber(stateIndex))
		updateBtnState(false)

		local indexRemove = -1
		local indexNormalTitleCard = -1
		for index = 0, mRealShowDataList:size() - 1 do
			if (indexRemove >= 0 and indexNormalTitleCard >= 0) then
				break
			end

			local item_data = mRealShowDataList:get(index)

			local appIdTemp = item_data:get("app_id")
			if (appIdTemp ~= nil) then
				if (appIdTemp:getString() == appId) then
					indexRemove = index
				end
			end

			local cardType = item_data:get("type")
			if (cardType ~= nil) then
				if (cardType:getString() == (mNormalCardTypeNormal .. "title")) then
					indexNormalTitleCard = index
				end
			end
		end

		mJavaBridge:Log("ClickIgnoreUpdate", "indexRemove:"..indexRemove..", indexNormalTitleCard:"..indexNormalTitleCard..", mNormalUpdateSizeTitle:"..mNormalUpdateSizeTitle)

		if (indexRemove > 0) then
			if (indexRemove < indexNormalTitleCard or mNormalUpdateSizeTitle <= 0) then
				--更新推荐更新卡标题内容
				local item_data = mRealShowDataList:get(0)

				mRecommendUpdateSizeTitle = mRecommendUpdateSizeTitle - 1
				local newTitle = mJavaBridge:create("var", mContextData:get("recommend_title"):getString() .. "（" .. mRecommendUpdateSizeTitle .. "）")
				item_data:put("title", newTitle)
				mRealShowDataList:set(0, item_data)
			else
				local item_data = mRealShowDataList:get(indexNormalTitleCard)
				
				mNormalUpdateSizeTitle = mNormalUpdateSizeTitle - 1
				local newTitle = mJavaBridge:create("var", mContextData:get("nomal_title"):getString() .. "（" .. mNormalUpdateSizeTitle .. "）")
				item_data:put("title", newTitle)
				mRealShowDataList:set(indexNormalTitleCard, item_data)
			end

			mJavaBridge:Log("ClickIgnoreUpdate", "clickIgnoreUpdate1 indexRemove: "..indexRemove)
			mRealShowViewList:remove(indexRemove)
			mRealShowDataList:remove(indexRemove)

			if (mRecommendUpdateSizeTitle == 0 and (indexRemove < indexNormalTitleCard or indexNormalTitleCard < 0)) then
				mRealShowViewList:remove(0)
				mRealShowDataList:remove(0)
				mRecommendUpdateSizeTitle = -1
			end

			if (mNormalUpdateSizeTitle == 0 and indexRemove > indexNormalTitleCard and indexNormalTitleCard >= 0) then
				mRealShowViewList:remove(indexNormalTitleCard)
				mRealShowDataList:remove(indexNormalTitleCard)
				mNormalUpdateSizeTitle = -1
			end

			mRecyclerView:getView():updateData(mRealShowDataList, mRealShowViewList, true)
		end
	end
end

function splitString(strInput, sep)
    if sep == nil then
        sep = "%s"
    end
    local t = {}; i = 1
    for str in string.gmatch(strInput, "([^" .. sep .. "]+)") do
        t[i] = str
        i = i + 1
    end
    return t
end

function allBtnReport(actionId)
	mJavaBridge:Log("UpdateListLoader", "设置margin")
	local sourcescene = getData("sourcescene")
	local sourcesceneslotid = getData("sourcesceneslotid")
	mJavaBridge:Log("UpdateListLoader", "sourcescene:"..sourcescene..", sourcesceneslotid:"..sourcesceneslotid)

    local actionRunner = mPhotonView:getParser():getTaskCenter():getActionRunner()	
    local params1 = {}
    params1["param"] =
	"scene:10110,actionid:"..actionId..",slotid:99_"..(mAppCount+1)..",subposition:1,modeltype:-1,source_modeltype:-1,appid:0,search_id:0,sourcescene:"..sourcescene..",sourceslot:"..sourcesceneslotid
	params1["extendparam"] = "report_element:button,uni_related_appid:data@uni_related_appid"
	params1["recommendid"] = "data@recommendid"
	actionRunner:run("reportaction", params1, nil)
end

function pageExposure()
	local sourcescene = getData("sourcescene")
	local sourcesceneslotid = getData("sourcesceneslotid")
	local uni_update_app_num = 0
	
	if mUpdateAppCount ~= 0 then
		-- body
		uni_update_app_num = 1
	end

	local actionRunner = mPhotonView:getParser():getTaskCenter():getActionRunner()	
    local params1 = {}
    params1["param"] =
	"scene:10110,actionid:100,slotid:-1,subposition:-1,source_scene=-1,sourceslot=-1,modeltype:-1,source_modeltype=-1,appid:0,search_id:0,sourcescene:"..sourcescene..",sourceslot:"..sourcesceneslotid
	params1["extendparam"] = "report_element:page,uni_button_expose:"..mDisplayBtn..",uni_update_app_num:"..uni_update_app_num
	actionRunner:run("reportaction", params1, nil)
end

function requestStartReport()
	local sourcescene = getData("sourcescene")
	local sourcesceneslotid = getData("sourcesceneslotid")

	local actionRunner = mPhotonView:getParser():getTaskCenter():getActionRunner()	
    local params1 = {}
    params1["param"] =
	"scene:10110,actionid:4000,slotid:-1,subposition:-1,source_scene=-1,sourceslot=-1,modeltype:-1,source_modeltype=-1,appid:0,search_id:0,sourcescene:"..sourcescene..",sourceslot:"..sourcesceneslotid
	params1["extendparam"] = "report_element:page"
	actionRunner:run("reportaction", params1, nil)
end

function reportUpdatePageLoadTime()
    local params = {}
    params["key"] = "report_update_list_data_rev"
    params["value"] = ""
	local actionRunner = mPhotonView:getParser():getTaskCenter():getActionRunner()	
	actionRunner:run("outeraction", params, nil)
end